<template>
  <div class="edit-popup">
    <popup
      ref="popupRef"
      :title="popupTitle"
      :async="true"
      width="500px"
      @confirm="handleSubmit"
      @close="handleClose"
    >
      <el-form
        ref="formRef"
        :model="formData"
        label-width="100px"
        :rules="formRules"
      >
        <el-form-item label="模板" prop="template_id">
          <el-select v-model="formData.template_id" clearable placeholder="请输入任务类型" >
                   <el-option
                    v-for="item in datalist"
                    :key="item.label"
                    :value="item.id"
                    :label="item.name"
                   />
        </el-select>
        </el-form-item>
        <el-form-item label="公司" prop="company_id">
          <el-input
            @click="openCompany"
            v-model="formData.company_name"
            clearable
            placeholder="请输入公司"
          />
        </el-form-item>
        <el-form-item label="下发公司类型" prop="type">
          <el-input
            v-model="formData.type"
            clearable
            placeholder="请输入下发公司类型"
          />
        </el-form-item>
        <el-form-item label="状态" prop="status">
          <el-radio-group v-model="formData.status">
            <el-radio :label="1">是</el-radio>
            <el-radio :label="0">否</el-radio>
          </el-radio-group>
        </el-form-item>
      </el-form>
    </popup>
    <el-dialog v-model="isCompany" title="选择签约方" width="60%">
      <DialogIndex @customEvent="customEvent" :type="indexType" />
    </el-dialog>
  </div>
</template>
<script lang="ts" setup name="taskSchedulingEdit">
//  <el-input v-model="formData.status" clearable placeholder="请输入状态" />
import type { FormInstance } from "element-plus";
import Popup from "@/components/popup/index.vue";
import {
  apiTaskSchedulingAdd,
  apiTaskSchedulingEdit,
  apiTaskSchedulingDetail,
} from "@/api/task_scheduling";
import { timeFormat } from "@/utils/util";
import type { PropType } from "vue";
import DialogIndex from "./dialog_index.vue";
import { dictDataLists } from "@/api/setting/dict";
defineProps({
  dictData: {
    type: Object as PropType<Record<string, any[]>>,
    default: () => ({}),
  },
});
const emit = defineEmits(["success", "close"]);
const formRef = shallowRef<FormInstance>();
const popupRef = shallowRef<InstanceType<typeof Popup>>();
const mode = ref("add");
const isCompany = ref(false);
const datalist=ref([])

// 弹窗标题
const popupTitle = computed(() => {
  return mode.value == "edit" ? "编辑任务公司排期" : "新增任务公司排期";
});

function openCompany() {
  isCompany.value = true;
}

function customEvent(data: any) {
  isCompany.value = false;
  formData.company_id = data.id;
  formData.company_name = data.company_name;
}

dictDataLists({ type_id: 10 }).then((res) => {
  datalist.value = res.lists;
});


// 表单数据
const formData = reactive({
  id: "",
  template_id: "",
  company_id: "",
  company_name: "",
  type: "",
  status: "",
});

// 表单验证
const formRules = reactive<any>({});

// 获取详情
const setFormData = async (data: Record<any, any>) => {
  for (const key in formData) {
    if (data[key] != null && data[key] != undefined) {
      //@ts-ignore
      formData[key] = data[key];
    }
  }
};

const getDetail = async (row: Record<string, any>) => {
  const data = await apiTaskSchedulingDetail({
    id: row.id,
  });
  setFormData(data);
};

// 提交按钮
const handleSubmit = async () => {
  await formRef.value?.validate();
  const data = { ...formData };
  mode.value == "edit"
    ? await apiTaskSchedulingEdit(data)
    : await apiTaskSchedulingAdd(data);
  popupRef.value?.close();
  emit("success");
};

//打开弹窗
const open = (type = "add") => {
  mode.value = type;
  popupRef.value?.open();
};

// 关闭回调
const handleClose = () => {
  emit("close");
};

defineExpose({
  open,
  setFormData,
  getDetail,
});
</script>
